<!DOCTYPE html>
<html>
  <head lang="en">
    <meta charset="utf-8" />
    <meta content="width=device-width" name="viewport" />
    <title>Voice for Browser</title>
    <link
      href="https://fonts.googleapis.com/css?family=Open+Sans:300,400,600,700"
      rel="stylesheet"
    />
    <link
      href="https://fonts.googleapis.com/icon?family=Material+Icons+Round"
      rel="stylesheet"
    />
    <link
      href="https://fonts.googleapis.com/icon?family=Material+Icons+Outlined"
      rel="stylesheet"
    />
    <style>
      body {
        color: #39006c;
        overflow: hidden;
        margin: 0;
      }
    </style>
  </head>
  <body>
    <webrtc-client-ui></webrtc-client-ui>

    <script>
      const webrtc = document.querySelector("webrtc-client-ui");
      const handler = (e) => console.log(e);

      function setUsername(username) {
        parent.document.getElementById(
          "username"
        ).innerHTML = `Welcome, <b>${username}</b>`;
      }

      function setCallIds(detail) {
        if (detail.isConsulted) {
          parent.document.getElementById("consulted_call_id").innerHTML =
            detail.callId;
        } else {
          parent.document.getElementById("call_id").innerHTML = detail.callId;
        }
      }

      webrtc.addEventListener("init", (e) => {
        console.log(e);
        parent.document.getElementById("controls").style = "display: none;";
        parent.document.getElementById("login").style = "display: grid;";
      });

      webrtc.addEventListener("logged-in", (e) => {
        console.log(e);
        parent.document.getElementById("login").style = "display: none;";
        parent.document.getElementById("controls").style = "display: grid;";
      });

      webrtc.addEventListener("call-incoming", (e) => {
        console.log(e);
        setCallIds(e.detail);
      });

      webrtc.addEventListener("call-started", (e) => {
        console.log(e);
        setCallIds(e.detail);
      });

      webrtc.addEventListener("call-in-progress", handler);
      webrtc.addEventListener("call-confirmed", handler);
      webrtc.addEventListener("call-answered", handler);
      webrtc.addEventListener("call-ended", handler);
      webrtc.addEventListener("call-paused", handler);
      webrtc.addEventListener("call-resumed", handler);
      webrtc.addEventListener("call-muted", handler);
      webrtc.addEventListener("call-unmuted", handler);
      webrtc.addEventListener("call-transfer-started", handler);
      webrtc.addEventListener("call-transfer-cancel", handler);
      webrtc.addEventListener("call-transfer-success", handler);
      webrtc.addEventListener("user-status-changed", handler);
      webrtc.addEventListener("user-role-changed", handler);
      webrtc.addEventListener("phone-error", handler);
      webrtc.addEventListener("restart-phone", handler);
      webrtc.addEventListener("auth-token-expired", handler);
      webrtc.addEventListener("call-supervising-state-changed", handler);

      window.addEventListener("message", function (e) {
        let data;

        try {
          data = JSON.parse(e.data);
        } catch (err) {
          data = {};
        }

        if ("discoveryUrl" in data) {
          webrtc
            .setDiscoveryUrl(data.discoveryUrl)
            .then(console.info, console.error);
        }

        if (data.action === "login_authheader") {
          if (
            "authHeader" in data &&
            "expiresIn" in data &&
            "userId" in data &&
            "username" in data
          ) {
            setUsername(data.username);
            webrtc
              .loginUsingAuthHeader(
                { value: data.authHeader, expiresIn: data.expiresIn },
                data.userId,
                data.username,
                true,
                data.siloName
              )
              .catch(console.error);
          } else {
            console.error("Missing data for login_authheader");
          }
          return;
        } else if (data.action === "login_sso") {
          if ("username" in data) {
            setUsername(data.username);
            webrtc
              .loginUsingSSO(data.username, true, undefined, data.siloName)
              .then(console.info, console.error);
          } else {
            console.error("Missing data for login_sso");
          }
          return;
        } else if (data.action === "login_username_password") {
          if ("username" in data && "password" in data) {
            setUsername(data.username);
            webrtc
              .loginUsingUsernameAndPassword(
                data.username,
                data.password,
                true,
                data.siloName
              )
              .catch(console.error);
          } else {
            console.error("Missing data for login_username_password");
          }
          return;
        }

        if ("allocationTimeout" in data) {
          webrtc
            .makeAPICall("POST", "/users/[ME]/features/calls/allocate-next/", {
              TTLSeconds: data.allocationTimeout,
            })
            .then(console.info, console.error);
        }

        if (
          "targetNumber" in data &&
          "callbackListId" in data &&
          "callbackRequestId" in data
        ) {
          webrtc
            .callOutboundCallback(
              data.targetNumber,
              data.callbackListId,
              data.callbackRequestId,
              data.cli
            )
            .then(console.info, console.error);
        } else if ("targetNumber" in data && "queueId" in data) {
          webrtc
            .callOutboundQueue(data.targetNumber, data.queueId, data.cli)
            .then(console.info, console.error);
        } else if ("targetNumber" in data) {
          webrtc.call(data.targetNumber);
        }

        if (data.action === "start_call_supervision" && "targetUserId" in data) {
          webrtc.startCallSupervision(data.targetUserId);
        }

        if ("callAction" in data && "targetId" in data) {
          switch (data.callAction) {
            case "answer":
              webrtc.answerCall(data.targetId);
              break;
            case "reject":
              webrtc.rejectCall(data.targetId);
              break;
            case "end":
              webrtc.endCall(data.targetId);
              break;
            case "mute":
              webrtc.muteCall(data.targetId);
              break;
            case "unmute":
              webrtc.unmuteCall(data.targetId);
              break;
            case "pause":
              webrtc.pauseCall(data.targetId);
              break;
            case "resume":
              webrtc.resumeCall(data.targetId);
              break;
            case "start":
              webrtc.startCallRecording(data.targetId);
              break;
            case "stop":
              webrtc.stopCallRecording(data.targetId);
              break;
          }
        }

        if ("alertsEnabled" in data) {
          webrtc.setPhoneAlertsUsage(data.alertsEnabled === "true");
        }

        if ("lang" in data) {
          webrtc.setPhoneLanguage(data.lang);
        }

        if ("audioHandling" in data) {
          webrtc
            .setAudioHandling(data.audioHandling)
            .then(console.info, console.error);
        }

        if ("data" in data) {
          webrtc
            .setUserData(JSON.parse(data.data))
            .then(console.info, console.error);
        }

        if ("transferType" in data && "transferToNumber" in data) {
          webrtc
            .transferCall(data.transferType, data.transferToNumber)
            .then(console.info, console.error);
        }

        if ("confirmTransfer" in data) {
          webrtc.confirmTransfer().then(console.info, console.error);
        }

        if ("getUserStatus" in data) {
          webrtc.getUserStatus().then(console.info, console.error);
        }

        if ("logout" in data) {
          webrtc.logout();
        }
      });
    </script>
    <script src="https://phone.enreachvoice.com/2025.1.0/webrtc-client-ui.min.js"></script>
  </body>
</html>
